Data label in EJ2 JavaScript Maps control

22 Sep 202324 minutes to read

Data labels provide information to users about the shapes of the Maps control. It can be enabled by setting the visible property of the dataLabelSettings to true.

Adding data labels

To display the data labels in the Maps, set the field name containing the text to be displayed from the data source or shape data in the labelPath property of the dataLabelSettings property.

In the following example, the value of labelPath property is set from the field name in the shape data of the Maps layer.

var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            shapeSettings: {
                autofill: true
            },
            dataLabelSettings: {
                visible: true,
                labelPath: 'name',
            }
        }
    ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">


    <script src="usa.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

In the following example, the value of labelPath property is set from the field name in the data source of the layer settings.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        shapePropertyPath: 'name',
        shapeDataPath: 'name',
        dataLabelSettings: {
            visible: true,
            labelPath: "continent",
            smartLabelMode: 'Trim'
        },
        dataSource: [
            { "name": "Afghanistan", "value": 53, "countryCode": "AF", "population": "29863010", "color": "red", "density": "119", "continent": "Asia" },
            { "name": "Albania", "value": 117, "countryCode": "AL", "population": "3195000", "color": "Blue", "density": "111", "continent": "Europe" },
            { "name": "Algeria", "value": 15, "countryCode": "DZ", "population": "34895000", "color": "Green", "density": "15", "continent": "Africa" }
        ],
        shapeSettings: {
            autofill: true
        }
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>


    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customization

The following properties are available in the dataLabelSettings to customize the data label of the Maps control.

  • border - To customize the color, width and opacity for the border of the data labels in Maps.
  • fill - To apply the color of the data labels in Maps.
  • opacity - To customize the transparency of the data labels in Maps.
  • textStyle - To customize the text style of the data labels in Maps.
var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            shapeSettings: {
                autofill: true
            },
            dataLabelSettings: {
                visible: true,
                labelPath: 'name',
                smartLabelMode: 'Hide',
                intersectionAction: 'Trim',
                border: {
                    color: 'green',
                    width: 2
                },
                fill: 'transparent',
                opacity: 0.9,
                textStyle: {
                    size: '17px',
                    fontStyle: 'Sans-serif',
                    fontWeight: 'normal'
                }
            },
            tooltipSettings: {
                visible: true,
                valuePath: 'name'
            }
        }
    ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">


    <script src="usa.js"></script>


    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Label animation

The data labels can be animated during the initial rendering of the Maps. This can be enabled by setting the animationDuration property in the dataLabelSettings of the Maps. The duration of the animation is specified in milliseconds.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: usa_map,
        dataLabelSettings: {
            visible: true,
            labelPath: 'name',
            smartLabelMode: 'Hide',
            intersectionAction: 'Trim',
            animationDuration: 2000,
        },
        shapeSettings: {
            autofill: true,
        },
        tooltipSettings: {
            visible: true,
            valuePath: 'name',
        },
    }]
});

map.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="usa.js"></script>
    
<script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>
   

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Smart labels

The Maps control provides an option to handle the labels when they intersect with the corresponding shape borders using the smartLabelMode property. The following options are available in the smartLabelMode property.

  • None - It specifies that no action is taken, when a label exceeds the shape’s region.
  • Hide - It specifies to hide the labels, when it exceeds the shape’s region.
  • Trim - It specifies to trim the labels, when it exceeds the shape’s region.
var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            shapeSettings: {
                autofill: true
            },
            dataLabelSettings: {
                visible: true,
                labelPath: 'name',
                smartLabelMode: 'Hide'
            }
        }
    ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="usa.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Intersect action

The Maps component provides an option to handle the labels when a label intersects with another label using the intersectionAction property. The following options are available in the intersectionAction property.

  • None - It specifies that no action is taken, when the labels intersect.
  • Hide - It specifies to hide the labels when they intersect.
  • Trim - It specifies to trim the labels when they intersect.
var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            shapeSettings: {
                autofill: true
            },
            dataLabelSettings: {
                visible: true,
                labelPath: 'name',
                intersectionAction: 'Trim'
            }
        }
    ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="usa.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Adding data label as a template

Any HTML elements can be added as a template in the data labels by using the template property of dataLabelSettings in the Maps control.

The properties of data label such as, smartLabelMode , intersectionAction, animationDuration, border, fill, opacity and textStyle properties are not applicable to template property. The styles can be applied to the label template using the CSS styles of the HTML element.

var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            shapeDataPath: 'Name',
            shapePropertyPath: 'name',
            dataSource: [
              { Name: 'Iowa', Population: 29863010 },
              { Name: 'Utah', Population: 1263010 },
              { Name: 'Texas', Population: 963010 }
            ],
            shapeSettings: {
                autofill: true
            },
            dataLabelSettings: {
                visible: true,
                labelPath: 'Name',
                template: '<div><div><img src="https://ej2.syncfusion.com/demos/src/maps/images/weather-clear.png" style="width:22px;height:22px"> </div> ${Name}</img></div>'
            }
        }
    ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="usa.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Data label in React Maps component

23 Sep 202324 minutes to read

Data labels provide information to users about the shapes of the Maps component. It can be enabled by setting the visible property of the dataLabelSettings to true.

Adding data labels

To display data labels in the Maps, the labelPath property of dataLabelSettings must be used. The value of the labelPath property can be taken from the field name in the shape data or data source. In the following example, the value of the labelPath property is the field name in the shape data of the Maps layer.

import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                               dataLabelSettings={ {
                                   visible: true,
                                   labelPath: 'name'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                               dataLabelSettings={ {
                                   visible: true,
                                   labelPath: 'name'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

In the following example, the value of labelPath property is set from the field name in the data source of the layer settings.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map} shapePropertyPath="name" shapeDataPath="name"
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataSource ={ [
                                    { "name": "Afghanistan", "value": 53, "countryCode": "AF", "population": "29863010", "color": "red", "density": "119", "continent": "Asia" },
                                    { "name": "Albania", "value": 117, "countryCode": "AL", "population": "3195000", "color": "Blue", "density": "111", "continent": "Europe" },
                                    { "name": "Algeria", "value": 15, "countryCode": "DZ", "population": "34895000", "color": "Green", "density": "15", "continent": "Africa" }
                                ] }
                                dataLabelSettings={ {
                                    visible: true,
                                    labelPath: 'continent',
                                    smartLabelMode: 'Trim'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map} shapePropertyPath="name" shapeDataPath="name"
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataSource ={ [
                                    { "name": "Afghanistan", "value": 53, "countryCode": "AF", "population": "29863010", "color": "red", "density": "119", "continent": "Asia" },
                                    { "name": "Albania", "value": 117, "countryCode": "AL", "population": "3195000", "color": "Blue", "density": "111", "continent": "Europe" },
                                    { "name": "Algeria", "value": 15, "countryCode": "DZ", "population": "34895000", "color": "Green", "density": "15", "continent": "Africa" }
                                ] }
                                dataLabelSettings={ {
                                    visible: true,
                                    labelPath: 'continent',
                                    smartLabelMode: 'Trim'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Customization

The following properties are available in the dataLabelSettings to customize the data label of the Maps component.

  • border - To customize the color, width and opacity for the border of the data labels in Maps.
  • fill - To apply the color of the data labels in Maps.
  • opacity - To customize the transparency of the data labels in Maps.
  • textStyle - To customize the text style of the data labels in Maps.
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel, MapsTooltip } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel, MapsTooltip]} />
           <LayersDirective>
               <LayerDirective shapeData={usa_map}
                                shapeSettings= {{
                                   autofill: true
                                }}
                                dataLabelSettings={ {
                                   visible: true,
                                   smartLabelMode: 'Hide',
                                   intersectionAction: 'Trim',
                                   labelPath: 'name',
                                   border: {
                                       color: 'green',
                                       width: 2
                                   },
                                   fill: 'transparent',
                                   opacity: 0.9,
                                   textStyle: {
                                       size: '17px',
                                       fontStyle: 'Sans-serif',
                                       fontWeight: 'normal'
                                   }
                                } }
                                tooltipSettings= {{
                                  visible: true,
                                  valuePath: 'name'
                            }}>
               </LayerDirective>
        </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel, MapsTooltip } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel, MapsTooltip]} />
           <LayersDirective>
               <LayerDirective shapeData={usa_map}
                                shapeSettings= {{
                                   autofill: true
                                }}
                                dataLabelSettings={ {
                                   visible: true,
                                   smartLabelMode: 'Hide',
                                   intersectionAction: 'Trim',
                                   labelPath: 'name',
                                   border: {
                                       color: 'green',
                                       width: 2
                                   },
                                   fill: 'transparent',
                                   opacity: 0.9,
                                   textStyle: {
                                       size: '17px',
                                       fontStyle: 'Sans-serif',
                                       fontWeight: 'normal'
                                   }
                                } }
                                tooltipSettings= {{
                                  visible: true,
                                  valuePath: 'name'
                            }}>
               </LayerDirective>
        </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Label animation

The data labels can be animated during the initial rendering of the Maps. This can be enabled by setting the animationDuration property in the dataLabelSettings of the Maps. The duration of the animation is specified in milliseconds.

import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel, MapsTooltip } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel, MapsTooltip]} />
           <LayersDirective>
               <LayerDirective shapeData={usa_map}
                                shapeSettings= {{
                                   autofill: true
                                }}
                                dataLabelSettings={ {
                                   visible: true,
                                   smartLabelMode: 'Hide',
                                   intersectionAction: 'Trim',
                                   labelPath: 'name',
                                   animationDuration: 2000
                                } }
                                tooltipSettings= {{
                                  visible: true,
                                  valuePath: 'name'
                            }}>
               </LayerDirective>
        </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel, MapsTooltip } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel, MapsTooltip]} />
           <LayersDirective>
               <LayerDirective shapeData={usa_map}
                                shapeSettings= {{
                                   autofill: true
                                }}
                                dataLabelSettings={ {
                                   visible: true,
                                   smartLabelMode: 'Hide',
                                   intersectionAction: 'Trim',
                                   labelPath: 'name',
                                   animationDuration: 2000
                                } }
                                tooltipSettings= {{
                                  visible: true,
                                  valuePath: 'name'
                            }}>
               </LayerDirective>
        </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Smart labels

The Maps component provides an option to handle the labels when they intersect with the corresponding shape borders using the smartLabelMode property. The following options are available in the smartLabelMode property.

  • None
  • Hide
  • Trim
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataLabelSettings={ {
                                    visible: true,
                                    labelPath: 'name',
                                    smartLabelMode: 'Hide'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataLabelSettings={ {
                                    visible: true,
                                    labelPath: 'name',
                                    smartLabelMode: 'Hide'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Intersect action

The Maps component provides an option to handle the labels when a label intersects with another label using the intersectionAction property. The following options are available in the intersectionAction property.

  • None
  • Hide
  • Trim
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataLabelSettings= { {
                                    visible: true,
                                    labelPath: 'name',
                                    intersectionAction: 'Trim'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                <LayerDirective shapeData={usa_map}
                                shapeSettings= { {
                                    autofill: true
                                } }
                                dataLabelSettings= { {
                                    visible: true,
                                    labelPath: 'name',
                                    intersectionAction: 'Trim'
                                } }>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Adding data label as a template

The data label can be added as a template in the Maps component. The template property of dataLabelSettings is used to set the data label as a template. Any text or HTML element can be added as the template in data labels.

The properties of data label such as, smartLabelMode , intersectionAction, animationDuration, border, fill, opacity and textStyle properties are not applicable to template property. The styles can be applied to the label template using the CSS styles of the HTML element.

import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                    <LayerDirective shapeData={usa_map} shapePropertyPath="name" shapeDataPath="Name"
                                    dataSource ={ [
                                        { "Name": "Iowa", "Population": "29863010" },
                                        { "Name": "Utah", "Population": "1263010" },
                                        { "Name": "Texas"," Population": "963010" }
                                    ] }
                                    shapeSettings= {{
                                        autofill: true
                                    }}
                                    dataLabelSettings={ {
                                        visible: true,
                                        labelPath:'Name',
                                        template: '<div><div><img src="https://ej2.syncfusion.com/demos/src/maps/images/weather-clear.png" style="width:22px;height:22px"> </div> ${Name}</img></div>'
                                    } }>
                    </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Inject, DataLabel } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
        <MapsComponent >
        <Inject services={[DataLabel]} />
            <LayersDirective>
                    <LayerDirective shapeData={usa_map} shapePropertyPath="name" shapeDataPath="Name"
                                    dataSource ={ [
                                        { "Name": "Iowa", "Population": "29863010" },
                                        { "Name": "Utah", "Population": "1263010" },
                                        { "Name": "Texas"," Population": "963010" }
                                    ] }
                                    shapeSettings= {{
                                        autofill: true
                                    }}
                                    dataLabelSettings={ {
                                        visible: true,
                                        labelPath:'Name',
                                        template: '<div><div><img src="https://ej2.syncfusion.com/demos/src/maps/images/weather-clear.png" style="width:22px;height:22px"> </div> ${Name}</img></div>'
                                    } }>
                    </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);